*EQU FILE BEGINS HERE

#include ramvar.asm
#include vecdef.asm
#include charptrs.asm
#include main.asm
#include init.asm
#include dummy.asm
#include lcd.asm
#include bcd.asm
#include ic1isr.asm
#include ic2isr.asm
*#include ic3isr.asm
#include oc1isr.asm

EVBUBRD	EQU	$0100
EVBBRD	EQU	$C000
REGTOP	EQU	$1000
SCIVEC	EQU	$00C4
SPIVEC	EQU	$00C7
PAIVEC	EQU	$00CA
PAOVEC	EQU	$00CD
TOVVEC	EQU	$00D0
OC5VEC	EQU	$00D3			
OC4VEC	EQU	$00D6			
OC3VEC	EQU	$00D9			
OC2VEC	EQU	$00DC			
OC1VEC	EQU	$00DF			
IC3VEC	EQU	$00E2			
IC2VEC	EQU	$00E5			
IC1VEC	EQU	$00E8			
RTIVEC	EQU	$00EB
IRQVEC	EQU	$00EE			
XRQVEC	EQU	$00F1
SWIVEC	EQU	$00F4
ILLVEC	EQU	$00F7
COPVEC	EQU	$00FA
CLKVEC	EQU	$00FD

PORTA	EQU	$00
PORTB	EQU	$04
PORTC	EQU	$03
PORTCL	EQU	$05
DDRC	EQU	$07
PORTD	EQU	$08
DDRD	EQU	$09
PORTE	EQU	$0A

TCNT	EQU	$0E
TIC1	EQU	$10
TIC2	EQU	$12
TIC3	EQU	$14
TOC1	EQU	$16
TOC2	EQU	$18
TOC3	EQU	$1A
TOC4	EQU	$1C
TOC5	EQU	$1E
TOCFRC	EQU	$0B
TOC1M	EQU	$0C
TOC1D	EQU	$0D

TCTRL1	EQU	$20
TCTRL2	EQU	$21
TMASK1	EQU	$22
TMASK2	EQU	$24
TFLAG1	EQU	$23
TFLAG2	EQU	$25
	
PACTRL	EQU	$26
PACOUNT	EQU	$27

SPICTRL	EQU	$28
SPISTAT	EQU	$29
SPIDATA	EQU	$2A

SCIBAUD	EQU	$2B
SCICTR1	EQU	$2C
SCICTR2	EQU	$2D
SCISTAT	EQU	$2E
SCIDATA	EQU	$2F

ADCTRL	EQU	$30
ADR1	EQU	$31
ADR2	EQU	$32
ADR3	EQU	$33
ADR4	EQU	$34

PIOC	EQU	$03
OPTION	EQU	$39
COPRST	EQU	$3A
PPROG	EQU	$3B
HPRIO	EQU	$3C
INIT	EQU	$3D
TEST1	EQU	$3E
CONFIG	EQU	$3F

IC3BIT	EQU	%00000001
IC2BIT	EQU	%00000010
IC1BIT	EQU	%00000100
OC5BIT	EQU	%00001000
OC4BIT	EQU	%00010000
OC3BIT	EQU	%00100000
OC2BIT	EQU	%01000000
OC1BIT	EQU	%10000000

IC1TST	EQU	%00110000
IC2TST	EQU	%00001100
IC3TST	EQU	%00000011

IC1DISC	EQU	%00000000	
IC1RISE EQU	%00010000
IC1FALL	EQU	%00100000
IC1BOTH	EQU	%00110000

IC2DISC	EQU	%00000000
IC2RISE	EQU	%00000100
IC2FALL	EQU	%00001000
IC2BOTH	EQU	%00001100

IC3DISC	EQU	%00000000
IC3RISE	EQU	%00000001
IC3FALL	EQU	%00000010
IC3BOTH	EQU	%00000011

OC2DISC	EQU	%00000000
OC2TOGG	EQU	%01000000
OC2CLR	EQU	%10000000
OC2SET	EQU	%11000000

OC3DISC	EQU	%00000000
OC3TOGG	EQU	%00010000
OC3CLR	EQU	%00100000
OC3SET	EQU	%00110000

OC4DISC	EQU	%00000000
OC4TOGG	EQU	%00000100
OC4CLR	EQU	%00001000
OC4SET	EQU	%00001100

OC5DISC	EQU	%00000000
OC5TOGG	EQU	%00000001
OC5CLR	EQU	%00000010
OC5SET	EQU	%00000011

OC1MD7	EQU	%10000000
OC1MD6	EQU	%01000000
OC1MD5	EQU	%00100000
OC1MD4	EQU	%00010000
OC1MD3	EQU	%00001000

C_ENAB	EQU	%10000000
C_RWB	EQU	%01000000

ALL	EQU	%11111111

LEGON	EQU	%00000001		;LEGON IS THE BIT THAT TURNS ON THE SPEED CONTROL BOARDS ON PORTC

READ	EQU 	%00000110
CLRLCD	EQU	%00000001
CRSHOME	EQU	%00000010
SETDRAM	EQU	%10000000
SPKR	EQU	%00010000
LAST	EQU	%00001111
LNESZE	EQU	#8

CHRPTR	EQU	$D100
FREQ	EQU	4000
SAFEOS	EQU	750
OC2THR	EQU	100
OC2CNTP	EQU	10


*EQU FILE ENDS HERE
