*	ORG	$D600
IC1ISR:
	LDAA	TCTRL2,X
	ANDA	#IC1TST
	CMPA	#IC1RISE
	BEQ	IC1RISEFNC
	CMPA	#IC1FALL
	BEQ	IC1FALLFNC
	LDAA	#IC1BIT
	STAA	TFLAG1,X
	RTI

IC1RISEFNC:
	LDD	TIC1,X
	STD	PWM1RISE
	BCLR	TCTRL2,X,IC1TST
	LDAA	TCTRL2,X
	ORAA	#IC1FALL
	STAA	TCTRL2,X
	LDAA	#IC1BIT
	STAA	TFLAG1,X
	RTI

IC1FALLFNC:
	LDD	TIC1,X				;SAVE TIC1 REGISTER CONTENTS INTO D REGISTER
	STD	PWM1FALL			;SAVE D REGISTER INTO RAM SPACE
	BCLR	TCTRL2,X,IC1TST			;BIT CLEAR THE BITS RELATED TO IC1 CONTROL
	LDAA	TCTRL2,X			;LOAD TO A THE TIMER CONTROL REGISTER 2
	ORAA	#IC1RISE			;CHANGE ONLY THE BITS RELATED TO IC1 AND RISE
	STAA	TCTRL2,X			;STORE NEW SETTINGS TO CONTROL REGISTER2

	LDAA	PWM1FALL			;LOAD ACC A WITH THE FALLING MSB VALUE
	LDAB	PWM1RISE			;LOAD ACC B WITH THE RISING MSB VALUE
	CBA					;COMPARE B AND A (A - B) TO CHECK IF RISING IS LOWER THAN FALLING
	BLE	REVIC1IN			;IF FALLING IS LOWER THAN RISING JUMP TO SUB
	LDD	PWM1FALL			;LOAD ACC D WITH THE FALLING 16 BIT VALUE
	SUBD	PWM1RISE			;D = D - RISE 16 BIT VALUE
	STD	PWM1RES				;STORE PWM1 RESULT ON RAM

	JSR	OC2OFFCALC

	LDAA	#IC1BIT
	STAA	TFLAG1,X
	RTI

REVIC1IN:
	LDD	#$FFFF
	SUBD	PWM1RISE
	ADDD	PWM1FALL
	STD	PWM1RES

	JSR	OC2OFFCALC

	LDAA	#IC1BIT
	STAA	TFLAG1,X
	RTI

OC2OFFCALC:
	LDD	PWM1RES				;LOAD D WITH PWM1RES [2000->4000]
	SUBD	#SAFEOS				;D = D - 1000
	STD	OC2OFF				;STORE D IN OC2OFF DB MEM SPACE
	CPD	OC2BEF				;IS OC2OFF - OC2BEF POSITIVE?
	BLT	OC2BEFBIG			;IF OC2OFF - OC2BEF IS NEGATIVE BRANCH TO OC2BEFBIG
	SUBD	OC2BEF				;IF OC2OFF - OC2BEF IS POSITIVE D = D - OC2BEF
	BRA	THRES2COMP			;JUMP TO THE THRESHOLD 2 COMPUTE SUBROUTINE
OC2BEFBIG:
	LDD	OC2BEF				;D = OC2BEF
	SUBD	OC2OFF				;D = OC2BEF - OC2OFF
THRES2COMP:
	CPD	#OC2THR				;IS D = (|OC2OFF - OC2BEF| - OC2THR) NEGATIVE?
	BLT	OC2EQUAL			;RESULT IS NEGATIVE AND THUS LESS THAN THRESHOLD. JUMP TO INCREASE OC2EQCNT
	TST	OC2EQCNT			;LETS SEE IF OC2EQNT IS ALREADY ZERO
	BEQ	OC2CNTZERO			;SINCE OC2EQCNT IS ZERO IT WILL NOT BE DECREASED BUT MOTORS WILL BE SHUT OFF.
	DEC	OC2EQCNT			;SINCE OC2EQCNT IS NOT ZERO IT WILL BE DECREMENTED
	BRA	OC2TRAN				;JUMP TO TRANSPOSE THE NEW VALUE WITH THE OLD ONE
OC2EQUAL:
	LDAA	#OC2CNTP			;LOAD ACC A WITH THE BIGGEST OC2EQCNT VALUE POSSIBLE
	CMPA	OC2EQCNT			;IS OC2EQCNT TO THE TOP
	BEQ	OC2CNTOVF			;IF OC2EQCNT IS AT THE TOP, TURN MOTORS ON
	INC	OC2EQCNT			;IF OC2EQCNT IS NOT AT THE TOP, INCREASE IT
	BRA	OC2TRAN				;JUMP TO TRANSPOSE THE NEW VALUE WITH THE OLD ONE
OC2CNTZERO:
	BCLR	PORTC,X,LEGON			;TURN OFF MOTORS
	BRA	OC2TRAN
OC2CNTOVF:
	BSET	PORTC,X,LEGON
OC2TRAN:
	LDD	OC2OFF
	STD	OC2BEF
	RTS

*HERE ENDS THE SERVICE ROUTINES FOR INPUT CAPTURE 1