	ORG	$D800
IC3ISR:
	LDAA	TCTRL2,X
	ANDA	#IC3TST
	CMPA	#IC3RISE
	BEQ	IC3RISEFNC
	CMPA	#IC3FALL
	BEQ	IC3FALLFNC
	LDAA	#IC3BIT
	STAA	TFLAG1,X
	RTS

IC3RISEFNC:
	LDD	TIC3,X
	STD	PWM3RISE
	BCLR	TCTRL2,X,IC3TST
	LDAA	TCTRL2,X
	ORAA	#IC3FALL
	STAA	TCTRL2,X
	LDAA	#IC3BIT
	STAA	TFLAG1,X
	RTS

IC3FALLFNC:
	LDD	TIC3,X				;SAVE TIC1 REGISTER CONTENTS INTO D REGISTER
	STD	PWM3FALL			;SAVE D REGISTER INTO IC3 FALL RAM SPACE
	BCLR	TCTRL2,X,IC3TST			;BIT CLEAR ALL THE BITS RELATED TO IC1 CONTROL
	LDAA	TCTRL2,X			;LOAD TO A THE TIMER CONTROL REGISTER 2
	ORAA	#IC3RISE			;CHANGE ONLY THE BITS RELATED TO IC1 FOR RISE ACTION
	STAA	TCTRL2,X			;STORE NEW SETTINGS ON CONTROL REGISTER2

	LDAA	PWM3FALL			;LOAD ACC A WITH THE FALLING MSB VALUE
	LDAB	PWM3RISE			;LOAD ACC B WITH THE RISING MSB VALUE
	CBA					;COMPARE B AND A (A - B) TO CHECK IF RISING IS LOWER THAN FALLING
	BLE	REVIC3IN			;IF FALLING IS LOWER THAN RISING JUMP TO SUB
	LDD	PWM3FALL			;LOAD ACC D WITH THE FALLING 16 BIT VALUE
	SUBD	PWM3RISE			;D = D - RISE 16 BIT VALUE
	STD	PWM3RES				;STORE PWM1 RESULT ON RAM

	JSR	CALCACTION			;CALCULATE ACTION ACCORDING TO KEY PRESSED

	LDAA	#IC3BIT				;NORMAL PROCEDURE TO CLEAR THE IC3 FLAG
	STAA	TFLAG1,X
	RTS

REVIC3IN:
	LDD	#$FFFF				;D = $FFFF (MAXIMUM TIMER REGISTER VALUE)
	SUBD	PWM3RISE			;D = $FFFF - PWM3RISE (TIME FRACTION AFTER TIMER OVERFLOW)
	ADDD	PWM3FALL			;D = $FFFF - PWM3RISE + PWM3FALL (TOTAL TIME)
	STD	PWM3RES				;STORE PWM3 RESULT ON PWM3RES RAM SPACE

	JSR	CALCACTION			;CALCULATE ACTION ACCORDING TO KEY PRESSED

	LDAA	#IC3BIT				;NORMAL PROCEDURE TO CLEAR THE IC3 FLAG
	STAA	TFLAG1,X
	RTS

CALCACTION:
	LDD	PWM3RES
	
	RTS

*HERE ENDS THE SERVICE ROUTINES FOR INPUT CAPTURE 3