*	INITIALIZE SUBROUTINE IS USED TO INITIALIZE PORT	*
*	DIRECTION, TIMER SETTINGS, AND OTHER MISCELANEOUS ITEMS	*
	
INITIALIZE:
	LDAA	#OC2CLR|OC3CLR|OC4CLR		;SET OC2 AND OC3 TO CLEAR OUTPUTS
	STAA	TCTRL1,X 			;TIMER CONTROL REGISTER 1 INITIALIZED	
	LDAA	#IC1RISE|IC2RISE|IC3RISE	;INPUT CAPTURES 1,2 AND 3 SET TO RISING EDGE
	STAA	TCTRL2,X 			;TIMER CONTROL REGISTER INITIALIZED
	LDAA	#OC1BIT|IC1BIT|IC2BIT		;ENABLE IC1, IC2 AND OC1 INTERRUPTS
	STAA	TMASK1,X 			;TIMER MASK REGISTER INITIALIZED

	CLR	TOC1M,X
	CLR	TOC1D,X
	BSET	TOC1M,X,OC1MD6|OC1MD5		;ATTACH OC2 AND OC3 TO OC1
	BSET	TOC1D,X,OC1MD6|OC1MD5		;MASKED OC2 AND OC3 SET TO RISING

	LDAA	#IC1BIT|IC2BIT|IC3BIT|OC1BIT	;CLEAR IC1, IC2, IC3 AND OC1 INT FLAGS
	STAA	TFLAG1,X

	BSET	DDRC,X,ALL			;SET PORT C AS OUTPUT
	CLR	SCICTR2,X			;TURN OF SCI COMM PORT (D) (TE AND RE = 0)
	RTS

*	VECINIT IS THE SUBROUTINE USED TO INITIALIZE THE 	*
*	BUFFALO VECTOR TABLE TO TRANSFORM THE EVB IN A STAND	*
*	ALONE PLATFORM. ALL INTERRUPTS ARE DEFINED ON ROM	*
*	UNDER THE LABEL VECTAB. SUBROUTINE FETCHES THE VECTOR	*
*	JUMP TABLE BYTE PER BYTE AND LOCALIZES EACH ON THE	*
*	RESERVED RAM SPACE. AN $FFFF SEQUENCE MARKS THE END 	*
*	OF STRING. SUBROUTINE SEARCH THIS SEQUENCE AND EXITS	*

VECINIT:
	PSHX					;SAVE INDEX REGISTERS CONTENTS
	PSHY
	LDY	#$00C4              		;C4 IS THE BUFFALO VECTOR TABLE ADDRESS
	LDX	#VECTAB				;VECTAB POINTS TO R2D2 SYSTEM VECTOR TABLE
NXTBYTE:
	LDAA	0,X				;WRITE BYTE BY BYTE ALL JMP VECTORS INTO BUFFALO RAM
	CMPA	#$FF
	BEQ	VECINITST			;IS THE CHARACTER EQUAL TO THE FIRST $FF EXIT CHARACTER?
CONT:	STAA	0,Y				;IF NOT COPY THE LEGITIMATE BYTE INTO THE BUFFALO RAM VECTOR TABLE
	INY
	INX
	BRA	NXTBYTE				;NEXT BYTE ON VECTOR TABLE IS TO BE FETCHED
VECINITST:
	INX
	LDAA	0,X
	CMPA	#$FF				;IS THERE AN $FF EXIT CHARACTER AFTER THE FIRST $FF
	BEQ	VECINITEX
	DEX
	BRA	CONT
VECINITEX:
	PULY					;IF TWO $FF CHARACTERS ARE FOUND, EXIT VECTOR INIT SUB
	PULX
	RTS
