*HERE BEGINS THE LCD SERVICE SUBROUTINES

LCDINIT:
*	LDAB	#$FF				;SET DRAM ADDRESS TO BEGINING
*	STAB	LCDAD

	LDD	#10000
	JSR	DELAY				;DELAY DEL INICIO

	LDAA	#$3F
	STAA	PORTB,X				;PRIMERA INSTRUCCION 0X3F
	JSR	ENABLE				;ASSERTING DE LA 1 INSTRUCCION
	LDD	#820
	JSR	DELAY				;DELAY DE LA PRIMERA INSTRUCCION

	JSR	ENABLE				;ASSERTING DE LA 2 INSTRUCCION
	LDD	#200
	JSR	DELAY				;DELAY DE LA SEGUNDA INSTRUCCION

	JSR	ENABLE				;ASSERTING DE LA 3 ONSTRUCCION
	LDD	#820
	JSR	DELAY				;DELAY DE LA TERCERA INSTRUCCION

	LDAA	#$3C
	STAA	PORTB,X				;CUARTA INSTRUCCION 0X3C
	JSR	ENABLE				;ASSERTING DE LA 4 INSTRUCCION	
	LDD	#8
	JSR	DELAY				;DELAY DE LA CUARTA INSTRUCCION

	LDAA	#$08		
	STAA	PORTB,X				;QUINTA INSTRUCCION 0X08
	JSR	ENABLE				;ASSERTING DE LA QUINTA INSTRUCCION	
	LDD	#8		
	JSR	DELAY				;DELAY DE LA QUINTA INSTRUCCION

	LDAA	#$0F			
	STAA	PORTB,X				;SEXTA INSTRUCCION 0X0F
	JSR	ENABLE				;ASSERTING DE LA SEXTA INSTRUCCION	
	LDD	#328
	JSR	DELAY				;DELAY DE LA SEXTA INSTRUCCION

	LDAA	#$06
	STAA	PORTB,X				;SEPTIMA INSTRUCCION 0X06
	JSR	ENABLE				;ASSERTING DE LA SEPTIMA INSTRUCCION	
	LDD	#8
	JSR	DELAY				;DELAY DE LA SEPTIMA INSTRUCCION
	RTS

LCDCLEAR:
	PSHA
	PSHB
	BCLR	PORTC,X,C_ENAB
	CLR	PORTB,X				;CLEAR DEL PUERTO B
	BSET	PORTB,X,#$01
	JSR	ENABLE
	LDD	#328
	JSR	DELAY
	PULB
	PULA
	RTS

LCDHOME:
	PSHA
	PSHB
	BCLR	PORTC,X,C_ENAB
	CLR	PORTB,X				;CLEAR DEL PUERTO B
	BSET	PORTB,X,#$02
	JSR	ENABLE
	LDD	#3280
	JSR	DELAY
	PULB
	PULA
	RTS

LCDSHIFL:
	PSHA
	PSHB
	LDAA	#$10				;SCROLL CURSOR LEFT 
	STAA	PORTB,X
	JSR	ENABLE
	LDD	#80
	JSR	DELAY
	JSR	LCDDECAD
	PULB
	PULA
	RTS	

LCDSHIFR:
	PSHA
	PSHB
	LDAA	#$14				;SCROLL CURSOR RIGHT
	STAA	PORTB,X
	JSR	ENABLE
	LDD	#80
	JSR	DELAY
	JSR	LCDINCAD
	PULB
	PULA
	RTS

LCDERASE:
	PSHA
	JSR	LCDSHIFL
	LDAA	#$20
	JSR	LCDWRITE
	JSR	LCDSHIFL
	PULA
	RTS	

LCDWRITE:
*	JSR	LCDINCAD
*	JSR	LCDSETDRAM	
	STAA	PORTB,X				;OUTPUT DE LA DATA EN ACC. A
	JSR	ENABLE
	LDD	#160
	JSR	DELAY				;DELAY DE LA INSTRUCCION DE WRITE
	RTS		

ENABLE:
	BSET	PORTC,X,C_ENAB
	BCLR	PORTC,X,C_ENAB
	RTS

DELAY:
	DECB
	TSTB
	BEQ	ACCADEC
	BRA 	DELAY
ACCADEC
	TSTA
	BEQ	DELAYOUT
	DECA
	BRA	DELAY
DELAYOUT
	RTS

LCDSETDRAM:	
	PSHA
	PSHB
	LDAB	LCDAD
	ORAB	#SETDRAM
	STAB	PORTB,X
	JSR	ENABLE
	LDD	#80
	JSR	DELAY
	PULB
	PULA
	RTS

LCDSETAD:
	PSHA
	PSHB
	LDAA	LCDAD
	SUBA	#7
	BLE	LCDSETA2
	LDAA	LCDAD
	ADDA	#16
	STAA	LCDAD
LCDSETA2:
	LDAA	#$80
	ORAA	LCDAD
	STAA	PORTB,X
	JSR	ENABLE
	LDD	#80
	JSR	DELAY
	PULB
	PULA
	RTS

LCDINCAD:
	PSHA
	PSHB
	INC	LCDAD
	LDAA	LCDAD
	CMPA	#LNESZE
	BLT	ADRDY
	CMPA	#48
	BEQ	ADTOP
	CMPA	#32
	BGE	ADRDY
	ADDA	#32
	BRA	ADRDY
ADTOP:	DECA
ADRDY:	STAA	LCDAD
	PULB
	PULA
	RTS

LCDDECAD:

	PSHA
	PSHB
	LDAA	LCDAD
	DECA
	CMPA	#00
	BLT	ADBOT
	CMPA	#LNESZE
	BLT	ADRDY
	CMPA	#40
	BGE	ADRDY
	SUBA	#32
	BRA	ADRDY
ADBOT:	INCA
	BRA	ADRDY

*HERE ENDS THE LCD SERVICE SUBROUTINE
